#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: generate_ost_list.pl, v1.2.0.0 Sun 12 Apr 2009 02:19:23 PM CEST mstauber Exp $
# Copyright 2006-2009 Solarspeed Ltd. and NuOnce Networks, Inc. All rights reserved.

# This handler / constructor updates the available OS templates list in CCE.

$whatami = "handler";

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Location of the vzlist-dump:
$vzlistdump = '/tmp/vserver-list';

# Location of vserver config files (directory - with trailing slash):
$vzcfgdir = '/etc/sysconfig/vz-scripts/';

# We are starting sane:
$bad_info_detected = '0';

# CCE'ize example VPS config files:
&sampleconfigs;

# CCE'ize existing OS-Templates:
&ostemplates;

$cce->bye('SUCCESS');
exit(0);

##
# Subs:
##

# Pull the existing sample VPS config files into CCE:
sub sampleconfigs {
    system ("rm -f /tmp/sampleconf");
    system("ls -k1 $vzcfgdir*.conf-sample | cut -d \/ -f5 |sed 's/ve-//'g | sed 's/.conf-sample//'g > /tmp/sampleconf");

    # Does the config file exist?
    $cfile = "/tmp/sampleconf";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

        # Find all previous VserverConfigSamples entries and destroy them:
        @oldsamples = $cce->findx('VserverConfigSamples', { 'nusol' => 'nusol' });
        for $entry (@oldsamples) {
            ($ok) = $cce->destroy($entry);
        }

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    # Populate CCE:
            ($ok) = $cce->create('VserverConfigSamples', {
            	    'nusol' => 'nusol',
            	    'ConfigShortName' => $line,
            	    'ConfigFullName' => 've-' . $line . '.conf-sample'
            	    });
        }
    }
    system ("rm -f /tmp/sampleconf");
}

# Pull the existing OS Templates into CCE:
sub ostemplates {
    if (!-d "/vz/template") {
	system("/bin/mkdir /vz/template");
    }
    if (!-d "/vz/template/cache") {
        system("/bin/mkdir /vz/template/cache");
    }
    if (!-f "/etc/vz/vz.conf") {

        if (!-d "/vz/cluster/") {
            system("/bin/mkdir /vz/cluster/");
        }
        if (!-d "/vz/cluster/etc") {
            system("/bin/mkdir /vz/cluster/etc");
        }
        if (!-d "/vz/cluster/etc/vz") {
            system("/bin/mkdir /vz/cluster/etc/vz");
        }
    
        if (!-d "/vz/cluster/etc/sysconfig") {
            system("/bin/mkdir /vz/cluster/etc/sysconfig");
        }
        if (!-d "/vz/cluster/etc/sysconfig/vz-scripts") {
            system("/bin/mkdir /vz/cluster/etc/sysconfig/vz-scripts");
        }
    }
    system ("rm -f /tmp/ostemplates");
    #system("ls -k1 /vz/template/cache/*.tar.gz |sed 's/\.tar\.gz//'g |sed 's/\/vz\/template\/cache\///'g > /tmp/ostemplates");
    system("ls -k1 /vz/template/cache/*.tar.gz |sed 's/\.tar\.gz//'g | cut -d / -f 5 > /tmp/ostemplates");

    # Does the dump file exist?
    $cfile = "/tmp/ostemplates";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

        # Find all previous VserverOStemplates entries and destroy them:
        @oldsamples = $cce->findx('VserverOStemplates', { 'OSTnusol' => 'nusol' });
        for $entry (@oldsamples) {
            ($ok) = $cce->destroy($entry);
        }

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    # Populate CCE:
            ($ok) = $cce->create('VserverOStemplates', {
            	    'OSTnusol' => 'nusol',
            	    'OStemplateShortName' => $line,
            	    'OStemplateFullName' => $line . '.tar.gz'
            	    });
        }
    }
    system ("rm -f /tmp/ostemplates");
}

$cce->bye('SUCCESS');
exit(0);

